package com.loafle.overflow.module.probe.dao;

import com.loafle.overflow.AppConfig;
import com.loafle.overflow.JdbcConfiguration;
import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.probe.type.ProbeStatusType;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.List;

/**
 * Created by root on 17. 6. 23.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class})
public class ProbeDAOTest {

    @Autowired
    private ProbeDAO probeDAO;

    @Test
    public void create() {

        Probe probe = new Probe();


        probe.setDescription("test probe");

        Domain domain = new Domain();
        domain.setId(1);

        probe.setDomain(domain);

        probe.setEncryptionKey("9c8d41ab57de11e7a2c9080027658d13");
        probe.setProbeKey("a1e1710557de11e78799080027658d13");
        probe.setStatus(ProbeStatusType.I);

        this.probeDAO.save(probe);

    }

    @Test
    public void getProbeKey() {

        Probe p = this.probeDAO.findByProbeKey("a1e1710557de11e78799080027658d13");



        Assert.assertNotEquals(p, null);

    }

    @Test
    public void getProbeList() {

        Domain domain = new Domain();
        domain.setId(1);
        List<Probe> ps = this.probeDAO.findAllByDomain(domain);


        Assert.assertNotEquals(ps.size(), 0);
    }
}